# __FSAState.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3String import *
from ATOM3Boolean import *
from graph_FSAState import *
class FSAState(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_FSAState
      self.parent = parent
      self.Name=ATOM3String('')
      self.keyword_= self.Name
      self.isInitial=ATOM3Boolean()
      self.isInitial.setValue(('Initial state?', 0))
      self.isInitial.config = 0
      self.isFinal=ATOM3Boolean()
      self.isFinal.setValue(('Final State?', 0))
      self.isFinal.config = 0
      self.generatedAttributes = {'Name': ('ATOM3String', ),
                                  'isInitial': ('ATOM3Boolean', ),
                                  'isFinal': ('ATOM3Boolean', )      }
   def show(self, parent, parentWindowInfo):
      ATOM3Type.show(self, parent, parentWindowInfo)
      self.containerFrame = Frame(parent)
      Label(self.containerFrame, text='Name').grid(row=0,column=0,sticky=W)
      self.Name.show(self.containerFrame, parentWindowInfo).grid(row=0,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'Name', 0, 2)
      Label(self.containerFrame, text='isInitial').grid(row=1,column=0,sticky=W)
      self.isInitial.show(self.containerFrame, parentWindowInfo).grid(row=1,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'isInitial', 1, 2)
      Label(self.containerFrame, text='isFinal').grid(row=2,column=0,sticky=W)
      self.isFinal.show(self.containerFrame, parentWindowInfo).grid(row=2,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'isFinal', 2, 2)
      ASGNode.editGGLabel(self, self.containerFrame, parentWindowInfo, 3)
      return self.containerFrame

   def toString(self, maxWide = None, maxLines = None ):
      rs = self.Name.toString()+' '+self.isInitial.toString()+' '+self.isFinal.toString()
      if maxWide: return self.strValue[0:maxWide-3]+'...'
      else: return rs


   def getValue(self):
      return (self.Name.getValue(),self.isInitial.getValue(),self.isFinal.getValue(),)

   def setValue(self, value):
      self.Name.setValue(value[0])
      self.isInitial.setValue(value[1])
      self.isFinal.setValue(value[2])

   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      "Method that writes into a file the constructor and the value of the object. Must be overriden in children"
      self.Name.writeConstructor2File(file, indent, objName+'.Name', depth, generatingCode)
      self.isInitial.writeConstructor2File(file, indent, objName+'.isInitial', depth, generatingCode)
      self.isFinal.writeConstructor2File(file, indent, objName+'.isFinal', depth, generatingCode)

   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      "Method that writes into a file the the value of the object. Must be overriden in children"
      self.Name.writeValue2File(file, indent, objName+'.Name', depth, generatingCode)
      self.isInitial.writeValue2File(file, indent, objName+'.isInitial', depth, generatingCode)
      self.isFinal.writeValue2File(file, indent, objName+'.isFinal', depth, generatingCode)

   def invalid(self):
      ASGNode.GGcheckSetNone(self)
      return self.Name.invalid() or self.isInitial.invalid() or self.isFinal.invalid() 

   def clone(self):
      cloneObject = FSAState( self.parent )
      cloneObject.Name = self.Name.clone()
      cloneObject.isInitial = self.isInitial.clone()
      cloneObject.isFinal = self.isFinal.clone()
      cloneObject.keyword_ = cloneObject.Name
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      self.Name = other.Name
      self.isInitial = other.isInitial
      self.isFinal = other.isFinal
      self.keyword_ = self.Name
      ASGNode.copy(self, other)

   def destroy(self):
      ASGNode.GGcheckSetNone(self)
      self.Name.destroy()
      self.isInitial.destroy()
      self.isFinal.destroy()
      self.containerFrame = None
   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None


