# __Table.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3String import *
from graph_Table import *
class Table(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_Table
      self.parent = parent
      self.Label=ATOM3String('')
      self.keyword_= self.Label
      self.Type=ATOM3String('')
      self.Lower_Limit=ATOM3String('')
      self.Interval_Size=ATOM3String('')
      self.Number_Of_Intervals=ATOM3String('')
      self.generatedAttributes = {'Label': ('ATOM3String', ),
                                  'Type': ('ATOM3String', ),
                                  'Lower_Limit': ('ATOM3String', ),
                                  'Interval_Size': ('ATOM3String', ),
                                  'Number_Of_Intervals': ('ATOM3String', )      }
   def show(self, parent, parentWindowInfo):
      ATOM3Type.show(self, parent, parentWindowInfo)
      self.containerFrame = Frame(parent)
      Label(self.containerFrame, text='Label').grid(row=0,column=0,sticky=W)
      self.Label.show(self.containerFrame, parentWindowInfo).grid(row=0,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'Label', 0, 2)
      Label(self.containerFrame, text='Type').grid(row=1,column=0,sticky=W)
      self.Type.show(self.containerFrame, parentWindowInfo).grid(row=1,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'Type', 1, 2)
      Label(self.containerFrame, text='Lower_Limit').grid(row=2,column=0,sticky=W)
      self.Lower_Limit.show(self.containerFrame, parentWindowInfo).grid(row=2,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'Lower_Limit', 2, 2)
      Label(self.containerFrame, text='Interval_Size').grid(row=3,column=0,sticky=W)
      self.Interval_Size.show(self.containerFrame, parentWindowInfo).grid(row=3,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'Interval_Size', 3, 2)
      Label(self.containerFrame, text='Number_Of_Intervals').grid(row=4,column=0,sticky=W)
      self.Number_Of_Intervals.show(self.containerFrame, parentWindowInfo).grid(row=4,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'Number_Of_Intervals', 4, 2)
      ASGNode.editGGLabel(self, self.containerFrame, parentWindowInfo, 5)
      return self.containerFrame

   def toString(self, maxWide = None, maxLines = None ):
      rs = self.Label.toString()+' '+self.Type.toString()+' '+self.Lower_Limit.toString()+' '+self.Interval_Size.toString()+' '+self.Number_Of_Intervals.toString()
      if maxWide: return self.strValue[0:maxWide-3]+'...'
      else: return rs


   def getValue(self):
      return (self.Label.getValue(),self.Type.getValue(),self.Lower_Limit.getValue(),self.Interval_Size.getValue(),self.Number_Of_Intervals.getValue(),)

   def setValue(self, value):
      self.Label.setValue(value[0])
      self.Type.setValue(value[1])
      self.Lower_Limit.setValue(value[2])
      self.Interval_Size.setValue(value[3])
      self.Number_Of_Intervals.setValue(value[4])

   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      "Method that writes into a file the constructor and the value of the object. Must be overriden in children"
      self.Label.writeConstructor2File(file, indent, objName+'.Label', depth, generatingCode)
      self.Type.writeConstructor2File(file, indent, objName+'.Type', depth, generatingCode)
      self.Lower_Limit.writeConstructor2File(file, indent, objName+'.Lower_Limit', depth, generatingCode)
      self.Interval_Size.writeConstructor2File(file, indent, objName+'.Interval_Size', depth, generatingCode)
      self.Number_Of_Intervals.writeConstructor2File(file, indent, objName+'.Number_Of_Intervals', depth, generatingCode)

   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      "Method that writes into a file the the value of the object. Must be overriden in children"
      self.Label.writeValue2File(file, indent, objName+'.Label', depth, generatingCode)
      self.Type.writeValue2File(file, indent, objName+'.Type', depth, generatingCode)
      self.Lower_Limit.writeValue2File(file, indent, objName+'.Lower_Limit', depth, generatingCode)
      self.Interval_Size.writeValue2File(file, indent, objName+'.Interval_Size', depth, generatingCode)
      self.Number_Of_Intervals.writeValue2File(file, indent, objName+'.Number_Of_Intervals', depth, generatingCode)

   def invalid(self):
      ASGNode.GGcheckSetNone(self)
      return self.Label.invalid() or self.Type.invalid() or self.Lower_Limit.invalid() or self.Interval_Size.invalid() or self.Number_Of_Intervals.invalid() 

   def clone(self):
      cloneObject = Table( self.parent )
      cloneObject.Label = self.Label.clone()
      cloneObject.Type = self.Type.clone()
      cloneObject.Lower_Limit = self.Lower_Limit.clone()
      cloneObject.Interval_Size = self.Interval_Size.clone()
      cloneObject.Number_Of_Intervals = self.Number_Of_Intervals.clone()
      cloneObject.keyword_ = cloneObject.Label
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      self.Label = other.Label
      self.Type = other.Type
      self.Lower_Limit = other.Lower_Limit
      self.Interval_Size = other.Interval_Size
      self.Number_Of_Intervals = other.Number_Of_Intervals
      self.keyword_ = self.Label
      ASGNode.copy(self, other)

   def destroy(self):
      ASGNode.GGcheckSetNone(self)
      self.Label.destroy()
      self.Type.destroy()
      self.Lower_Limit.destroy()
      self.Interval_Size.destroy()
      self.Number_Of_Intervals.destroy()
      self.containerFrame = None
   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None


