from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_Q(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 85, 58
        graphEntity.__init__(self, x, y)
        self.ChangesAtRunTime = 0
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_rectangle(self.translate([21.0, 14.0, 58.0, 43.0]), tags = self.tag, stipple= '', width= '1.0', outline= 'black', fill= '')
        self.gf0 = GraphicalForm(drawing, h, "gf0")
        self.graphForms.append(self.gf0)
        h = drawing.create_line(self.translate([25.0, 23.0, 52.0, 23.0, 52.0, 33.0, 25.0, 33.0]), tags = self.tag, stipple= '', splinesteps= '12', arrowshape= '8 10 3', smooth= 0, joinstyle= 'round', width= '1.0', arrow= 'none', capstyle= 'butt', fill= 'black')
        self.gf3 = GraphicalForm(drawing, h, "gf3")
        self.graphForms.append(self.gf3)
        h = drawing.create_line(self.translate([43.0, 25.0, 43.0, 33.0]), tags = self.tag, stipple= '', splinesteps= '12', arrowshape= '8 10 3', smooth= 0, joinstyle= 'round', width= '1.0', arrow= 'none', capstyle= 'butt', fill= 'black')
        self.gf4 = GraphicalForm(drawing, h, "gf4")
        self.graphForms.append(self.gf4)
        h = drawing.create_line(self.translate([37.0, 25.0, 37.0, 33.999999999999993]), tags = self.tag, stipple= '', splinesteps= '12', arrowshape= '8 10 3', smooth= 0, joinstyle= 'round', width= '1.0', arrow= 'none', capstyle= 'butt', fill= 'black')
        self.gf7 = GraphicalForm(drawing, h, "gf7")
        self.graphForms.append(self.gf7)
        h = drawing.create_rectangle(self.translate([57.0, 20.0, 61.0, 33.0]), tags = self.tag, stipple= '', width= '1.0', outline= 'black', fill= 'black')
        self.gf8 = GraphicalForm(drawing, h, "gf8")
        self.graphForms.append(self.gf8)
        h = drawing.create_rectangle(self.translate([20.0, 21.0, 24.0, 35.0]), tags = self.tag, stipple= '', width= '1.0', outline= 'black', fill= 'black')
        self.gf9 = GraphicalForm(drawing, h, "gf9")
        self.graphForms.append(self.gf9)
        h = drawing.create_text(self.translate([12.0, 14.0]), tags = self.tag, stipple= '', fill= 'black', text= 'in', width= '0', font= 'Helvetica -12', anchor= 'center', justify= 'left')
        self.gf6 = GraphicalForm(drawing, h, "gf6")
        self.graphForms.append(self.gf6)
        h = drawing.create_text(self.translate([68.0, 13.0]), tags = self.tag, stipple= '', fill= 'black', text= 'out', width= '0', font= 'Helvetica -12', anchor= 'center', justify= 'left')
        self.gf7 = GraphicalForm(drawing, h, "gf7")
        self.graphForms.append(self.gf7)
        h = drawing.create_oval(self.translate([22.0, 27.0, 22.0, 27.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'blue')
        self.connectors.append(h)
        self.namedConnectors[h] = "inport"
        h = drawing.create_oval(self.translate([58.0, 26.0, 58.0, 26.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'blue')
        self.connectors.append(h)
        self.namedConnectors[h] = "outport"
        if self.semanticObject: drawText = self.semanticObject.num_entities.toString(25,5)
        else: drawText = "<num_entities>"
        h = drawing.create_text(self.translate([41.999999999999993, 7.0]), tags = self.tag, text = drawText, stipple= '', fill= 'red', width= '0', font= 'Helvetica -12', anchor= 'center', justify= 'left')
        self.attr_display["num_entities"] = h
        self.gf9 = GraphicalForm(drawing, h, "gf9")
        self.graphForms.append(self.gf9)
        if self.semanticObject: drawText = self.semanticObject.Name.toString(25,5)
        else: drawText = "<Name>"
        h = drawing.create_text(self.translate([39.0, 51.0]), tags = self.tag, text = drawText, stipple= '', fill= 'blue', width= '0', font= 'Helvetica -12', anchor= 'center', justify= 'left')
        self.attr_display["Name"] = h
        self.gf8 = GraphicalForm(drawing, h, "gf8")
        self.graphForms.append(self.gf8)


    def postCondition (self, actionID, * params):
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_Q
