# __PostscriptOptions.py_____________________________________________________
from ASGNode import *
from ATOM3Type import *
from ATOM3Enum import *

class PostscriptOptions(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.parent = parent
      self.colormode=ATOM3Enum(['color', 'grey', 'mono'], 0, 0)
      self.rotate=ATOM3Enum(['portrait', 'canvas'], 0, 0)
      self.generatedAttributes = {'colormode': ('ATOM3Enum', ),
                                  'rotate': ('ATOM3Enum', )      }
      self.realOrder = ['colormode','rotate']
   def clone(self):
      cloneObject = PostscriptOptions( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      ASGNode.copy(self, other)



